//=============================================================================
// CASIO Mobile Device SystemLib Sample                                       +
// Copyright (C) 2005 CASIO COMPUTER CO., LTD. All Rights Reserved.           +
//=============================================================================
// buzzer.c : uU[Tv                                                  +
//-----------------------------------------------------------------------------
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <SystemLib.h>
#include "resource.h"

#define MAX_LOADSTRING		100
#define dim(x)				(sizeof(x) / sizeof(x[0]))
#define BUZZER_KEY			L"Drivers\\BuiltIn\\Buzzer\\UserDef"

// \̒`
typedef struct tagTYPELIST{
	DWORD	dwType;
	UINT	wID;
} TYPELIST;

typedef struct tagBUZZERSETTING{
	DWORD	dwMute;
	DWORD	dwVol;
	DWORD	dwHelz;
	DWORD	dwTime;
} BUZZERSETTING;


// O[oϐ
extern HINSTANCE			hInst;			// ݂̃CX^X
static int					nSelType;		// ݑIĂuU[^Cv
static BUZZERSETTING		OldSetting[7];	// ύXO̐ݒ
static BUZZERSETTING		NewSetting[7];	// ύX̐ݒ

const static TYPELIST TypeList[] = {
	{B_CLICK,		IDS_TYPE_CLICK},
	{B_ALARM,		IDS_TYPE_ALARM},
	{B_WARNING,		IDS_TYPE_WARNING},
	{B_SCANEND,		IDS_TYPE_SCANEND},
	{B_USERDEF,		IDS_TYPE_USERDEF},
	{B_TAP,			IDS_TYPE_TAP},
	{B_ALL,			IDS_TYPE_ALLBUZ},
};


// ֐̃vg^Cv錾
extern void				ShowErrorMessage	(HWND, LPCTSTR, DWORD);
static BOOL				GetBuzzerSetting	(HWND);
static BOOL				SetBuzzerSetting	(HWND, DWORD, BUZZERSETTING*);
static BOOL				SetUserDefSetting	(HWND, int);
static BOOL				InitBuzzerDlg		(HWND);
static BOOL				ChangeTypeSelect	(HWND, int);


// uU[_CAÕbZ[W
LRESULT CALLBACK BuzzerDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int nIndex;
	LONG nChecked;
	DWORD dwRet;
	int i;

	switch (message)
	{
	case WM_INITDIALOG:
		// ݒ擾_CAO
		GetBuzzerSetting(hDlg);
		InitBuzzerDlg(hDlg);
		return TRUE;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_TYPE:
			if(HIWORD(wParam) == CBN_SELENDOK){
				// uU[^CvύX
				nIndex = ComboBox_GetCurSel((HWND)lParam);
				ChangeTypeSelect(hDlg, nIndex);
			}
			break;

		case IDC_MUTE:
			// ~[gݒύX
			nChecked = Button_GetCheck((HWND)lParam);
			if(nChecked == 0)
			{
				NewSetting[nSelType].dwMute = FALSE;
			}
			else
			{
				NewSetting[nSelType].dwMute = TRUE;
			}
			SetBuzzerSetting(hDlg, TypeList[nSelType].dwType, &NewSetting[nSelType]);
			break;

		case IDC_HELZ:
		case IDC_TIME:
			if(HIWORD(wParam) == EN_KILLFOCUS)
			{
				// gAԕύX
				SetUserDefSetting(hDlg, nSelType);
			}
			break;

		case IDC_VOLUME:
			if(HIWORD(wParam) == CBN_SELENDOK){
				// ʕύX
				nIndex = ComboBox_GetCurSel((HWND)lParam);
				NewSetting[nSelType].dwVol = nIndex;
				SetBuzzerSetting(hDlg, TypeList[nSelType].dwType, &NewSetting[nSelType]);
			}
			break;

		case IDC_PLAY:
			//Đ
			dwRet = SysPlayBuzzer(
				TypeList[nSelType].dwType,
				NewSetting[nSelType].dwHelz,
				NewSetting[nSelType].dwTime);
			ShowErrorMessage(hDlg, L"SysPlayBuzzer", dwRet);
			break;

		case IDC_STOP:
			//~
			dwRet = SysStopBuzzer();
			ShowErrorMessage(hDlg, L"SysStopBuzzer", dwRet);
			break;

		case IDCANCEL:
			// ̐ݒɖ߂
			for(i = 0 ; i < dim(TypeList); i++)
			{
				SetBuzzerSetting(hDlg, TypeList[i].dwType, &OldSetting[i]);
			}
		case IDOK:
			// _CAO
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}


// uU[ݒ擾
static BOOL GetBuzzerSetting(HWND hDlg)
{
	DWORD dwMute;
	DWORD dwVol;
	int i;

	// ϐ
	nSelType = 0;
	memset(OldSetting, 0x00, sizeof(OldSetting));
	memset(NewSetting, 0x00, sizeof(NewSetting));

	// ~[gݒƃ{[擾
	for(i = 0 ; i < dim(TypeList); i++)
	{
		dwMute = SysGetBuzzerMute(TypeList[i].dwType);
		ShowErrorMessage(hDlg, L"SysGetBuzzerMute", dwMute);
		OldSetting[i].dwMute = dwMute;

		dwVol = SysGetBuzzerVolume(TypeList[i].dwType);
		ShowErrorMessage(hDlg, L"SysGetBuzzerVolume", dwVol);

		if(dwVol == BUZZERVOLUME_MIN)		OldSetting[i].dwVol = 0;
		else if(dwVol == BUZZERVOLUME_MID)	OldSetting[i].dwVol = 1;
		else if(dwVol == BUZZERVOLUME_MAX)	OldSetting[i].dwVol = 2;
	}

	// [U[ݒ̎gƎԂ擾
	for(i = 0 ; i < dim(TypeList); i++)
	{
		if(TypeList[i].dwType == B_USERDEF)
		{
			HKEY	hKey;
			DWORD	dwDisposition, dwData, dwType;
			LONG	lResult;

			// WXgI[v
			lResult = RegCreateKeyEx(HKEY_LOCAL_MACHINE, BUZZER_KEY, 0, L"",
				REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisposition);
			if(lResult != ERROR_SUCCESS)
			{
				return FALSE;
			}

			// g擾
			dwData	= sizeof(DWORD);
			dwType	= REG_DWORD;
			lResult = RegQueryValueEx(hKey, L"Freq", NULL, &dwType, (LPBYTE)&OldSetting[i].dwHelz, &dwData);
			if(lResult!=ERROR_SUCCESS){
				RegCloseKey(hKey);
				return FALSE;
			}

			// Ԏ擾
			dwData	= sizeof(DWORD);
			dwType	= REG_DWORD;
			lResult = RegQueryValueEx(hKey, L"Time", NULL, &dwType, (LPBYTE)&OldSetting[i].dwTime, &dwData);
			if(lResult!=ERROR_SUCCESS){
				RegCloseKey(hKey);
				return FALSE;
			}
			RegCloseKey(hKey);
			break;
		}
	}

	// ݒRs[
	memcpy(NewSetting, OldSetting, sizeof(OldSetting));
	return TRUE;
}


// uU[ݒXV
static BOOL SetBuzzerSetting(HWND hDlg, DWORD dwType, BUZZERSETTING *pSetting)
{
	DWORD dwVol;
	DWORD dwRet;

	// ~[gݒXV
	dwRet = SysSetBuzzerMute(dwType, pSetting->dwMute);
	ShowErrorMessage(hDlg, L"SysSetBuzzerMute", dwRet);

	// ʐݒXV
	if(pSetting->dwVol == 0)		dwVol = BUZZERVOLUME_MIN;
	else if(pSetting->dwVol == 1)	dwVol = BUZZERVOLUME_MID;
	else if(pSetting->dwVol == 2)	dwVol = BUZZERVOLUME_MAX;
	dwRet = SysSetBuzzerVolume(dwType, dwVol);
	ShowErrorMessage(hDlg, L"SysSetBuzzerVolume", dwRet);

	// [U[ݒȂ烌WXg̎gAԂXV
	if(dwType == B_USERDEF)
	{
		HKEY hKey;
		DWORD dwDisposition;
		LONG lResult;

		// WXgI[v
		lResult = RegCreateKeyEx(HKEY_LOCAL_MACHINE, BUZZER_KEY, 0, L"",
			REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisposition);
		if(lResult != ERROR_SUCCESS)
		{
			return FALSE;
		}

		// g
		lResult = RegSetValueEx(hKey, L"Freq", 0, REG_DWORD, (LPBYTE)&pSetting->dwHelz, sizeof(DWORD));
		if(lResult != ERROR_SUCCESS)
		{
			return FALSE;
		}

		// 
		lResult = RegSetValueEx(hKey, L"Time", 0, REG_DWORD, (LPBYTE)&pSetting->dwTime, sizeof(DWORD));
		if(lResult != ERROR_SUCCESS)
		{
			return FALSE;
		}
		RegCloseKey(hKey);
	}
	return TRUE;
}

// GfBbg{bNX̓͒lŃ[U[ݒXV
static BOOL SetUserDefSetting(HWND hDlg, int nIndex)
{
	TCHAR szTemp[256];
	BOOL bRet;

	// ݂̃uU[^Cv[U[ݒłȂΉȂ
	if(TypeList[nIndex].dwType != B_USERDEF)
	{
		return TRUE;
	}
	
	//g擾
	GetWindowText(GetDlgItem(hDlg, IDC_HELZ), szTemp, 256);
	NewSetting[nIndex].dwHelz = wcstoul(szTemp, NULL, 0);

	//Ԏ擾
	GetWindowText(GetDlgItem(hDlg, IDC_TIME), szTemp, 256);
	NewSetting[nIndex].dwTime = wcstoul(szTemp, NULL, 0);

	// ݒXV
	bRet = SetBuzzerSetting(hDlg, TypeList[nIndex].dwType, &NewSetting[nIndex]);
	return bRet;
}


// uU[_CAO
static BOOL InitBuzzerDlg(HWND hDlg)
{
	TCHAR szTemp[MAX_LOADSTRING];
	UINT wVolumeID[] = {IDS_VOLUME_MIN, IDS_VOLUME_MID, IDS_VOLUME_MAX};
	int i;

	// uU[^CvR{{bNX
	for(i = 0 ; i < dim(TypeList); i++)
	{
		LoadString(hInst, TypeList[i].wID, szTemp, MAX_LOADSTRING);
		ComboBox_AddString(GetDlgItem(hDlg, IDC_TYPE), szTemp);
	}

	// ʃR{{bNX
	for(i = 0 ; i < dim(wVolumeID); i++)
	{
		LoadString(hInst, wVolumeID[i], szTemp, MAX_LOADSTRING);
		ComboBox_AddString(GetDlgItem(hDlg, IDC_VOLUME), szTemp);
	}

	// IuU[^Cvݒ
	ComboBox_SetCurSel(GetDlgItem(hDlg, IDC_TYPE), nSelType);
	ChangeTypeSelect(hDlg, 0);
	return TRUE;
}


// uU[^CvύX
static BOOL ChangeTypeSelect(HWND hDlg, int nNewSel)
{
	TCHAR szTemp[256];

	// ύXÕuU[^Cv[U[ݒ肩
	if(TypeList[nSelType].dwType == B_USERDEF)
	{
		SetUserDefSetting(hDlg, nSelType);
	}

	// ~[gݒ
	if(NewSetting[nNewSel].dwMute == TRUE)
	{
		Button_SetCheck(GetDlgItem(hDlg, IDC_MUTE), BST_CHECKED);
	}
	else
	{
		Button_SetCheck(GetDlgItem(hDlg, IDC_MUTE), BST_UNCHECKED);
	}

	// 
	ComboBox_SetCurSel(GetDlgItem(hDlg, IDC_VOLUME), NewSetting[nNewSel].dwVol);

	// IuU[^Cv[U[ݒ肩
	if(TypeList[nNewSel].dwType == B_USERDEF)
	{
		// g
		wsprintf(szTemp, L"%d", NewSetting[nNewSel].dwHelz);
		SetWindowText(GetDlgItem(hDlg, IDC_HELZ), szTemp);
		EnableWindow(GetDlgItem(hDlg, IDC_HELZ), TRUE);

		// 
		wsprintf(szTemp, L"%d", NewSetting[nNewSel].dwTime);
		SetWindowText(GetDlgItem(hDlg, IDC_TIME), szTemp);
		EnableWindow(GetDlgItem(hDlg, IDC_TIME), TRUE);
	}
	else
	{
		// g
		SetWindowText(GetDlgItem(hDlg, IDC_HELZ), L"");
		EnableWindow(GetDlgItem(hDlg, IDC_HELZ), FALSE);

		// Ԗ
		SetWindowText(GetDlgItem(hDlg, IDC_TIME), L"");
		EnableWindow(GetDlgItem(hDlg, IDC_TIME), FALSE);
	}

	// IuU[^CvSނ
	if(TypeList[nNewSel].dwType == B_ALL)
	{
		EnableWindow(GetDlgItem(hDlg, IDC_VOLUME), FALSE);
		EnableWindow(GetDlgItem(hDlg, IDC_PLAY), FALSE);
	}
	else
	{
		EnableWindow(GetDlgItem(hDlg, IDC_VOLUME), TRUE);
		EnableWindow(GetDlgItem(hDlg, IDC_PLAY), TRUE);
	}

	// IuU[^CvύX
	nSelType = nNewSel;
	return TRUE;
}
