//=============================================================================
// CASIO Mobile Device SystemLib Sample                                       +
// Copyright (C) 2005 CASIO COMPUTER CO., LTD. All Rights Reserved.           +
//=============================================================================
// vibrator.c : oCu[^Tv                                          +
//-----------------------------------------------------------------------------
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <SystemLib.h>
#include "resource.h"

#define MAX_LOADSTRING		100
#define dim(x)				(sizeof(x) / sizeof(x[0]))
#define BUZZER_KEY			L"Drivers\\BuiltIn\\Buzzer\\UserDef"

// \̒`
typedef struct tagTYPELIST{
	DWORD	dwType;
	UINT	wID;
} TYPELIST;

typedef struct tagVIBRATORSETTING{
	DWORD	dwMute;
	DWORD	dwNum;
	DWORD	dwOnTime;
	DWORD	dwOffTime;
} VIBRATORSETTING;


// O[oϐ
extern HINSTANCE			hInst;			// ݂̃CX^X
static int					nSelType;		// ݑIĂU^Cv
static VIBRATORSETTING		OldSetting[6];	// ύXO̐ݒ
static VIBRATORSETTING		NewSetting[6];	// ύX̐ݒ

const static TYPELIST TypeList[] = {
	{B_ALARM,		IDS_TYPE_ALARM},
	{B_WARNING,		IDS_TYPE_WARNING},
	{B_SCANEND,		IDS_TYPE_SCANEND},
	{B_WIREREAD,	IDS_TYPE_WIREREAD},
	{B_USERDEF,		IDS_TYPE_USERDEF},
	{B_ALL,			IDS_TYPE_ALLVIB},
};


// ֐̃vg^Cv錾
extern void				ShowErrorMessage	(HWND, LPCTSTR, DWORD);
static BOOL				GetVibratorSetting	(HWND);
static BOOL				SetVibratorSetting	(HWND, DWORD, VIBRATORSETTING*);
static BOOL				SetUserDefSetting	(HWND, int);
static BOOL				InitVibratorDlg		(HWND);
static BOOL				ChangeTypeSelect	(HWND, int);


// oCu[^_CAÕbZ[W
LRESULT CALLBACK VibratorDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int nIndex;
	LONG nChecked;
	DWORD dwRet;
	int i;

	switch (message)
	{
	case WM_INITDIALOG:
		// ݒ擾_CAO
		GetVibratorSetting(hDlg);
		InitVibratorDlg(hDlg);
		return TRUE;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_TYPE:
			if(HIWORD(wParam) == CBN_SELENDOK){
				// U^CvύX
				nIndex = ComboBox_GetCurSel((HWND)lParam);
				ChangeTypeSelect(hDlg, nIndex);
			}
			break;

		case IDC_MUTE:
			// ~[gݒύX
			nChecked = Button_GetCheck((HWND)lParam);
			if(nChecked == 0)
			{
				NewSetting[nSelType].dwMute = FALSE;
			}
			else
			{
				NewSetting[nSelType].dwMute = TRUE;
			}
			SetVibratorSetting(hDlg, TypeList[nSelType].dwType, &NewSetting[nSelType]);
			break;

		case IDC_NUM:
		case IDC_ONTIME:
		case IDC_OFFTIME:
			if(HIWORD(wParam) == EN_KILLFOCUS)
			{
				// 񐔁AUIԁAUItԕύX
				SetUserDefSetting(hDlg, nSelType);
			}
			break;

		case IDC_PLAY:
			// Đ
			dwRet = SysPlayVibrator(
				TypeList[nSelType].dwType,
				NewSetting[nSelType].dwNum,
				NewSetting[nSelType].dwOnTime,
				NewSetting[nSelType].dwOffTime);
			ShowErrorMessage(hDlg, L"SysPlayVibrator", dwRet);
			break;

		case IDC_STOP:
			// ~
			SysStopVibrator();
			break;

		case IDCANCEL:
			// ̐ݒɖ߂
			for(i = 0 ; i < dim(TypeList); i++)
			{
				SetVibratorSetting(hDlg, TypeList[i].dwType, &OldSetting[i]);
			}
		case IDOK:
			// _CAO
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}


// uU[ݒ擾
static BOOL GetVibratorSetting(HWND hDlg)
{
	DWORD dwMute;
	int i;

	// ϐ
	nSelType = 0;
	memset(OldSetting, 0x00, sizeof(OldSetting));
	memset(NewSetting, 0x00, sizeof(NewSetting));

	// ~[gݒ擾
	for(i = 0 ; i < dim(TypeList); i++)
	{
		dwMute = SysGetVibratorMute(TypeList[i].dwType);
		ShowErrorMessage(hDlg, L"SysGetVibratorMute", dwMute);
		OldSetting[i].dwMute = dwMute;
	}

	// ݒRs[
	memcpy(NewSetting, OldSetting, sizeof(OldSetting));
	return TRUE;
}


// oCu[^ݒXV
static BOOL SetVibratorSetting(HWND hDlg, DWORD dwType, VIBRATORSETTING *pSetting)
{
	DWORD dwRet;

	// ~[gݒXV
	dwRet = SysSetVibratorMute(dwType, pSetting->dwMute);
	ShowErrorMessage(hDlg, L"SysSetVibratorMute", dwRet);

	return TRUE;
}

// GfBbg{bNX̓͒lŃ[U[ݒXV
static BOOL SetUserDefSetting(HWND hDlg, int nIndex)
{
	TCHAR szTemp[256];

	// ݂̐U^Cv[U[ݒłȂΉȂ
	if(TypeList[nIndex].dwType != B_USERDEF)
	{
		return TRUE;
	}

	// 񐔎擾
	GetWindowText(GetDlgItem(hDlg, IDC_NUM), szTemp, 256);
	NewSetting[nIndex].dwNum = wcstoul(szTemp, NULL, 0);

	// UIԎ擾
	GetWindowText(GetDlgItem(hDlg, IDC_ONTIME), szTemp, 256);
	NewSetting[nIndex].dwOnTime = wcstoul(szTemp, NULL, 0);

	// UItԎ擾
	GetWindowText(GetDlgItem(hDlg, IDC_OFFTIME), szTemp, 256);
	NewSetting[nIndex].dwOffTime = wcstoul(szTemp, NULL, 0);

	return TRUE;
}

// oCu[^_CAO
static BOOL InitVibratorDlg(HWND hDlg)
{
	TCHAR szTemp[MAX_LOADSTRING];
	int i;

	// U^CvR{{bNX
	for(i = 0 ; i < dim(TypeList); i++)
	{
		LoadString(hInst, TypeList[i].wID, szTemp, MAX_LOADSTRING);
		ComboBox_AddString(GetDlgItem(hDlg, IDC_TYPE), szTemp);
	}

	// IU^Cvݒ
	ComboBox_SetCurSel(GetDlgItem(hDlg, IDC_TYPE), nSelType);
	ChangeTypeSelect(hDlg, 0);
	return TRUE;
}

// U^CvύX
static BOOL ChangeTypeSelect(HWND hDlg, int nNewSel)
{
	TCHAR szTemp[256];

	// ύXO̐U^Cv[U[ݒ肩
	if(TypeList[nSelType].dwType == B_USERDEF)
	{
		SetUserDefSetting(hDlg, nSelType);
	}

	// ~[gݒ
	if(NewSetting[nNewSel].dwMute == TRUE)
	{
		Button_SetCheck(GetDlgItem(hDlg, IDC_MUTE), BST_CHECKED);
	}
	else
	{
		Button_SetCheck(GetDlgItem(hDlg, IDC_MUTE), BST_UNCHECKED);
	}

	// IU^Cv[U[ݒ肩
	if(TypeList[nNewSel].dwType == B_USERDEF)
	{
		// U
		wsprintf(szTemp, L"%d", NewSetting[nNewSel].dwNum);
		SetWindowText(GetDlgItem(hDlg, IDC_NUM), szTemp);
		EnableWindow(GetDlgItem(hDlg, IDC_NUM), TRUE);

		// UI
		wsprintf(szTemp, L"%d", NewSetting[nNewSel].dwOnTime);
		SetWindowText(GetDlgItem(hDlg, IDC_ONTIME), szTemp);
		EnableWindow(GetDlgItem(hDlg, IDC_ONTIME), TRUE);

		// UIt
		wsprintf(szTemp, L"%d", NewSetting[nNewSel].dwOffTime);
		SetWindowText(GetDlgItem(hDlg, IDC_OFFTIME), szTemp);
		EnableWindow(GetDlgItem(hDlg, IDC_OFFTIME), TRUE);
	}
	else
	{
		// U񐔖
		SetWindowText(GetDlgItem(hDlg, IDC_NUM), L"");
		EnableWindow(GetDlgItem(hDlg, IDC_NUM), FALSE);
		
		// UIԖ
		SetWindowText(GetDlgItem(hDlg, IDC_ONTIME), L"");
		EnableWindow(GetDlgItem(hDlg, IDC_ONTIME), FALSE);

		// UItԖ
		SetWindowText(GetDlgItem(hDlg, IDC_OFFTIME), L"");
		EnableWindow(GetDlgItem(hDlg, IDC_OFFTIME), FALSE);
	}

	// IU^CvSނ
	if(TypeList[nNewSel].dwType == B_ALL)
	{
		EnableWindow(GetDlgItem(hDlg, IDC_PLAY), FALSE);
	}
	else
	{
		EnableWindow(GetDlgItem(hDlg, IDC_PLAY), TRUE);
	}

	// IU^CvύX
	nSelType = nNewSel;
	return TRUE;
}
